package jp.nyatla.andnya3;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.nio.IntBuffer;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import javax.microedition.khronos.opengles.GL10;

import jp.androidgroup.nyartoolkit.markersystem.*;
import jp.androidgroup.nyartoolkit.sketch.*;
import jp.androidgroup.nyartoolkit.utils.camera.CameraPreview;
import jp.androidgroup.nyartoolkit.utils.gl.*;
import jp.nyatla.arbozu.R;
import jp.nyatla.nyartoolkit.markersystem.NyARMarkerSystemConfig;
import jp.nyatla.nymmd.AndMmdMotionPlayer;
import jp.nyatla.nymmd.AndMmdPmdModel;
import jp.nyatla.nymmd.AndMmdVmdMotion;
import jp.nyatla.nymmd.MmdException;
import android.annotation.SuppressLint;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.hardware.Camera;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.provider.MediaStore.Images;
import android.speech.RecognitionListener;
import android.speech.RecognizerIntent;
import android.speech.SpeechRecognizer;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.*;

@SuppressLint("SimpleDateFormat")
public class AndMmdActivity extends AndSketch implements AndGLView.IGLFunctionEvent, RecognitionListener {
	private SpeechRecognizer mSpeechRecognizer;
	private AndMmdVmdMotion motStd;
	private AndMmdVmdMotion motWait[];
	private AndMmdVmdMotion motAct[];
	private Calendar mCalendar;
	private Runnable mTicker = null;
	private boolean mTickerStopped;
	private Timer mTimer = null;
	private SoundPool mSoundPool;
	private int soundRes[];
	private int mPixels[] = null;
	private int pixelWidth = 0, pixelHeight = 0;
	private boolean isCaptured = false;
	private Random mRandom;
	
	private Button btnMic;
	private Button btnCam;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
		this.setContentView(R.layout.main);
		this.setVolumeControlStream(AudioManager.STREAM_MUSIC);
		
		// 音声認識
		this.mSpeechRecognizer = SpeechRecognizer.createSpeechRecognizer(this);
        this.mSpeechRecognizer.setRecognitionListener(this);
        
        this.mRandom = new Random();
        
		this.btnMic = (Button) this.findViewById(R.id.buttonMic);
		this.btnMic.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
                intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
                intent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, getPackageName());
                mSpeechRecognizer.startListening(intent);
            }
        });
		
		this.btnCam = (Button) this.findViewById(R.id.buttonCam);
		this.btnCam.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	if(!isCaptured) {
            		isCaptured = true;
                	_camera_preview.getCamera().takePicture(mShutterListener, null, mPictureListener);
            	}
            }
        });
    }
	
	CameraPreview _camera_preview;
	AndGLView _glv;
	Camera.Size _cap_size = null;
	/**
	 * onStartでは、Viewのセットアップをしてください。
	 */
	@Override
	public void onStart()
	{
		super.onStart();
		
		FrameLayout fr = (FrameLayout) this.findViewById(R.id.sketchLayout);
		int sw = this.getWindowManager().getDefaultDisplay().getWidth();
		int sh = this.getWindowManager().getDefaultDisplay().getHeight();

		if(sw>640){
			sw/=2;
			sh/=2;
		}
		//カメラの取得
		this._camera_preview = new CameraPreview(this);
		this._cap_size = this._camera_preview.getRecommendPreviewSize(sw, sh);
		
		// 画面サイズの計算
		int h = this.getWindowManager().getDefaultDisplay().getHeight();
//		int h = sh;
		int screen_w,screen_h;
		screen_w=(this._cap_size.width*h/this._cap_size.height);
//		screen_w=(this._cap_size.height*h/this._cap_size.width);
		screen_h=h;
		
		// camera
		fr.addView(this._camera_preview, 0, new LayoutParams(screen_w, screen_h));
		//GLview
		this._glv = new AndGLView(this);
		fr.addView(this._glv, 0, new LayoutParams(screen_w, screen_h));
		
		// mmd screen
		this.mPixels = new int[screen_w * screen_h];
		this.pixelWidth = screen_w;
		this.pixelHeight = screen_h;
		
		// calendar
		this.mCalendar = Calendar.getInstance();
		this.initCalendar();
	}
	
	private void initCalendar() {
		final ImageView hour1 = (ImageView) this.findViewById(R.id.imageHour1);
		final ImageView hour2 = (ImageView) this.findViewById(R.id.imageHour2);
		final ImageView min1 = (ImageView) this.findViewById(R.id.imageMin1);
		final ImageView min2 = (ImageView) this.findViewById(R.id.imageMin2);
		final ImageView month1 = (ImageView) this.findViewById(R.id.imageMonth1);
		final ImageView month2 = (ImageView) this.findViewById(R.id.imageMonth2);
		final ImageView day1 = (ImageView) this.findViewById(R.id.imageDay1);
		final ImageView day2 = (ImageView) this.findViewById(R.id.imageDay2);
		final ImageView week = (ImageView) this.findViewById(R.id.imageWeek);
		
		final int timeRes[] = new int[10];
		timeRes[0] = R.drawable.time0;
		timeRes[1] = R.drawable.time1;
		timeRes[2] = R.drawable.time2;
		timeRes[3] = R.drawable.time3;
		timeRes[4] = R.drawable.time4;
		timeRes[5] = R.drawable.time5;
		timeRes[6] = R.drawable.time6;
		timeRes[7] = R.drawable.time7;
		timeRes[8] = R.drawable.time8;
		timeRes[9] = R.drawable.time9;
		
		final int dateRes[] = new int[10];
		dateRes[0] = R.drawable.date0;
		dateRes[1] = R.drawable.date1;
		dateRes[2] = R.drawable.date2;
		dateRes[3] = R.drawable.date3;
		dateRes[4] = R.drawable.date4;
		dateRes[5] = R.drawable.date5;
		dateRes[6] = R.drawable.date6;
		dateRes[7] = R.drawable.date7;
		dateRes[8] = R.drawable.date8;
		dateRes[9] = R.drawable.date9;
		
		final int weekRes[] = new int[7];
		weekRes[0] = R.drawable.week1;
		weekRes[1] = R.drawable.week2;
		weekRes[2] = R.drawable.week3;
		weekRes[3] = R.drawable.week4;
		weekRes[4] = R.drawable.week5;
		weekRes[5] = R.drawable.week6;
		weekRes[6] = R.drawable.week7;
		
		final Handler handler = new Handler();
        this.mTickerStopped = false;
		this.mTicker = new Runnable() {
                public void run() {
                    if (mTickerStopped) return;
                    mCalendar.setTimeInMillis(System.currentTimeMillis());
            		hour1.setImageResource(timeRes[mCalendar.get(Calendar.HOUR_OF_DAY)/10]);
            		hour2.setImageResource(timeRes[mCalendar.get(Calendar.HOUR_OF_DAY)%10]);
        			min1.setImageResource(timeRes[mCalendar.get(Calendar.MINUTE)/10]);
            		min2.setImageResource(timeRes[mCalendar.get(Calendar.MINUTE)%10]);
            		if((mCalendar.get(Calendar.MONTH) + 1)/10 == 0) {
            			month1.setImageResource(R.drawable.dummy);
            		} else {
            			month1.setImageResource(dateRes[(mCalendar.get(Calendar.MONTH) + 1)/10]);
            		}
            		month2.setImageResource(dateRes[(mCalendar.get(Calendar.MONTH) + 1)%10]);
            		if(mCalendar.get(Calendar.DAY_OF_MONTH)/10 == 0) {
            			day1.setImageResource(R.drawable.dummy);
            		} else {
            			day1.setImageResource(dateRes[mCalendar.get(Calendar.DAY_OF_MONTH)/10]);
            		}
            		day2.setImageResource(dateRes[mCalendar.get(Calendar.DAY_OF_MONTH)%10]);
            		week.setImageResource(weekRes[mCalendar.get(Calendar.DAY_OF_WEEK) - 1]);
                    long now = SystemClock.uptimeMillis();
                    long nextTime = now + (60000 - mCalendar.getTimeInMillis() % 60000);
                    handler.postAtTime(mTicker, nextTime);
                }
            };
        this.mTicker.run();
	}
	
	@Override
	public void onStop() {
		super.onStop();
		
		if(this.mSoundPool != null) {
			this.mSoundPool.release();
			this.finish();
		}
	}
	
	private int _mid;
	AndGLTextLabel text;
	AndGLBox box;
	AndGLFpsLabel fps;
	AndMmdMotionPlayer _player;
	NyARAndMarkerSystem _ms;
	NyARAndSensor _ss;
	public void setupGL(GL10 gl)
	{
		try
		{
			// Sound
			this.mSoundPool = new SoundPool(4, AudioManager.STREAM_MUSIC, 0);
			this.soundRes = new int[14];
			for(int i=0;i<this.soundRes.length;i++) {
				this.soundRes[i] = this.mSoundPool.load(this, R.raw.dummy, 1);
			}
//			this.soundRes[0] = this.mSoundPool.load(this, R.raw.hello0, 1);
//			this.soundRes[1] = this.mSoundPool.load(this, R.raw.hello1, 1);
//			this.soundRes[2] = this.mSoundPool.load(this, R.raw.bye0, 1);
//			this.soundRes[3] = this.mSoundPool.load(this, R.raw.happy0, 1);
//			this.soundRes[4] = this.mSoundPool.load(this, R.raw.fight0, 1);
//			this.soundRes[5] = this.mSoundPool.load(this, R.raw.fight1, 1);
//			this.soundRes[6] = this.mSoundPool.load(this, R.raw.sad0, 1);
//			this.soundRes[7] = this.mSoundPool.load(this, R.raw.sad1, 1);
//			this.soundRes[8] = this.mSoundPool.load(this, R.raw.sleep0, 1);
//			this.soundRes[9] = this.mSoundPool.load(this, R.raw.oops0, 1);
//			this.soundRes[10] = this.mSoundPool.load(this, R.raw.jump0, 1);
//			this.soundRes[11] = this.mSoundPool.load(this, R.raw.mic0, 1);
//			this.soundRes[12] = this.mSoundPool.load(this, R.raw.fanfare0, 1);
//			this.soundRes[13] = this.mSoundPool.load(this, R.raw.janken0, 1);
			for(int i=0;i<this.soundRes.length;i++) {
				int flg = 0;
				while(flg == 0) {
			    	flg = this.mSoundPool.play(this.soundRes[i], 0.0f, 0.0f, 0, 0, 1.0f);
				}
			}
			
			AssetManager assetMng = getResources().getAssets();

			// モーションの読み込み
			this.motStd = new AndMmdVmdMotion(assetMng,"Motion/stand.vmd");
			
			this.motWait = new AndMmdVmdMotion[8];
			this.motWait[0] = new AndMmdVmdMotion(assetMng,"Motion/turn.vmd");
			this.motWait[1] = new AndMmdVmdMotion(assetMng,"Motion/jump.vmd");
			this.motWait[2] = new AndMmdVmdMotion(assetMng,"Motion/seat.vmd");
			this.motWait[3] = new AndMmdVmdMotion(assetMng,"Motion/sleep.vmd");
			this.motWait[4] = new AndMmdVmdMotion(assetMng,"Motion/squat.vmd");
			this.motWait[5] = new AndMmdVmdMotion(assetMng,"Motion/stretch.vmd");
			this.motWait[6] = new AndMmdVmdMotion(assetMng,"Motion/shake.vmd");
			this.motWait[7] = new AndMmdVmdMotion(assetMng,"Motion/sky.vmd");
			
			this.motAct = new AndMmdVmdMotion[15];
			this.motAct[0] = new AndMmdVmdMotion(assetMng,"Motion/poyo.vmd");
			this.motAct[1] = new AndMmdVmdMotion(assetMng,"Motion/hello.vmd");
			this.motAct[2] = new AndMmdVmdMotion(assetMng,"Motion/bye.vmd");
			this.motAct[3] = new AndMmdVmdMotion(assetMng,"Motion/happy.vmd");
			this.motAct[4] = new AndMmdVmdMotion(assetMng,"Motion/sad.vmd");
			this.motAct[5] = new AndMmdVmdMotion(assetMng,"Motion/punch.vmd");
			this.motAct[6] = new AndMmdVmdMotion(assetMng,"Motion/mic.vmd");
			this.motAct[7] = new AndMmdVmdMotion(assetMng,"Motion/dance.vmd");
			
			this.motAct[8] = new AndMmdVmdMotion(assetMng,"Motion/jan_g.vmd");
			this.motAct[9] = new AndMmdVmdMotion(assetMng,"Motion/jan_c.vmd");
			this.motAct[10] = new AndMmdVmdMotion(assetMng,"Motion/jan_p.vmd");
			this.motAct[11] = new AndMmdVmdMotion(assetMng,"Motion/away_t.vmd");
			this.motAct[12] = new AndMmdVmdMotion(assetMng,"Motion/away_b.vmd");
			this.motAct[13] = new AndMmdVmdMotion(assetMng,"Motion/away_l.vmd");
			this.motAct[14] = new AndMmdVmdMotion(assetMng,"Motion/away_r.vmd");
			
			//create sensor controller.
			this._ss=new NyARAndSensor(this._camera_preview,this._cap_size.width,this._cap_size.height,30);
			//create marker system
			this._ms=new NyARAndMarkerSystem(new NyARMarkerSystemConfig(this._cap_size.width,this._cap_size.height));
			this._mid=this._ms.addARMarker(assetMng.open("AR/data/kirby.pat"),16,25,80);
			this._ss.start();
			
			//setup openGL Camera Frustum
			gl.glMatrixMode(GL10.GL_PROJECTION);
			gl.glLoadMatrixf(this._ms.getGlProjectionMatrix(),0);

			this._player = new AndMmdMotionPlayer(gl);
//			this._player.lookMeEnable(true);
			this._player.setPmd(new AndMmdPmdModel(assetMng,"Model/kirby.pmd"));
			this._player.setVmd(this.getNextMotion());
			
			this._debug=new AndGLDebugDump(this._glv);
			this.text=new AndGLTextLabel(this._glv);
			this.fps=new AndGLFpsLabel(this._glv,"MarkerPlaneActivity");
			this.box=new AndGLBox(this._glv,1);
			
			gl.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
			gl.glEnable(GL10.GL_DEPTH_TEST);

			gl.glEnable(GL10.GL_BLEND);
			gl.glBlendFunc(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);

			gl.glEnable(GL10.GL_ALPHA_TEST);
			gl.glAlphaFunc(GL10.GL_GEQUAL, 0.05f);

			float[] fLightPos = { 0.45f, 0.55f, 1.0f, 0.0f };
			float[] fLightDif = { 0.9f, 0.9f, 0.9f, 0.0f };
			float[] fLightAmb = { 1.0f, 1.0f, 1.0f, 0.0f };
			float[] fLightSpq = { 0.9f, 0.9f, 0.9f, 0.0f };
			gl.glLightfv(GL10.GL_LIGHT0, GL10.GL_POSITION, fLightPos, 0);
			gl.glLightfv(GL10.GL_LIGHT0, GL10.GL_DIFFUSE, fLightDif, 0);
			gl.glLightfv(GL10.GL_LIGHT0, GL10.GL_AMBIENT, fLightAmb, 0);
			gl.glLightfv(GL10.GL_LIGHT0, GL10.GL_SPECULAR, fLightSpq, 0);
			gl.glEnable(GL10.GL_LIGHT0);
			gl.glEnable(GL10.GL_LIGHTING);
			
			this.animation_start_time=System.currentTimeMillis();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			this.finish();
		}
	}
	
	private static final float PROB_STAND = 1.0f;
	private float prob = PROB_STAND;
	private AndMmdVmdMotion getNextMotion() {
		if(this.mRandom.nextFloat() < this.prob) {	// 静止を出力
			this.prob *= 0.9f;
			return this.motStd;
		} else {	// てきとーな振舞を出力
			this.prob = PROB_STAND;
			int ret = this.mRandom.nextInt(this.motWait.length);
			return this.motWait[ret];
		}
	}
	
	private void changeMotion(AndMmdVmdMotion mot) {
		try {
			this._player.setVmd(mot);
			this.animation_start_time = System.currentTimeMillis();
		} catch (MmdException e) {
			e.printStackTrace();
		}
	}
	
	AndGLDebugDump _debug=null;
	private long animation_start_time;
	/**
	 * 継承したクラスで表示したいものを実装してください
	 * @param gl
	 */
	public void drawGL(GL10 gl)
	{
		try{
			//背景塗り潰し色の指定
			gl.glClearColor(0,0,0,0);
	        //背景塗り潰し
	        gl.glClear(GL10.GL_COLOR_BUFFER_BIT|GL10.GL_DEPTH_BUFFER_BIT);
	        if(ex!=null){
	        	_debug.draw(ex);
	        	return;
	        }
	        
	        long progTime = System.currentTimeMillis()-this.animation_start_time;
	        if(progTime/this._player.getTimeLength() >= 1) {
	        	this.changeMotion(this.getNextMotion());
	        }
			this._player.updateMotion(progTime%this._player.getTimeLength());
			
			synchronized(this._ss){
				this._ms.update(this._ss);
				if(this._ms.isExistMarker(this._mid)) {
//			        this.text.draw("found"+this._ms.getConfidence(this._mid),0,16);
					gl.glPushMatrix();
					gl.glMatrixMode(GL10.GL_MODELVIEW);
					gl.glEnable(GL10.GL_LIGHTING);
					gl.glLoadIdentity();
					gl.glLoadMatrixf(this._ms.getGlMarkerMatrix(this._mid),0);
					gl.glRotatef(90,1,0,0);
					gl.glScalef(8.0f, 8.0f, -8.0f); // 左手系 → 右手系
					this._player.render();
					gl.glPopMatrix();
				}
			}
//			fps.draw(0, 0);
			
			final IntBuffer buffer = IntBuffer.wrap(this.mPixels);
			buffer.position(0);
			gl.glReadPixels(0, 0, this.pixelWidth, this.pixelHeight, GL10.GL_RGBA, GL10.GL_UNSIGNED_BYTE, buffer);
		}catch(Exception e)
		{
			ex=e;
		}
	}
	Exception ex=null;

	@Override
	public void onReadyForSpeech(Bundle arg0) {
//	    Toast.makeText(this, "音声認識準備完了", Toast.LENGTH_SHORT).show();
	    this.btnMic.setBackgroundResource(R.drawable.button_rec);
	    this.detectTimeout();
	}

	@Override
	public void onBeginningOfSpeech() {
//	    Toast.makeText(this, "入力開始", Toast.LENGTH_SHORT).show();
	    this.mTimer.cancel();
	}

	@Override
	public void onBufferReceived(byte[] arg0) {
		// TODO 自動生成されたメソッド・スタブ
		
	}

	@Override
	public void onEndOfSpeech() {
//	    Toast.makeText(this, "入力終了", Toast.LENGTH_SHORT).show();
	    this.btnMic.setBackgroundResource(R.drawable.button_mic);
	    this.mTimer = null;
	}

	@Override
	public void onError(int error) {
	    switch (error) {
	    case SpeechRecognizer.ERROR_AUDIO:
	        // 音声データ保存失敗
//	        Toast.makeText(this, "audio error", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_CLIENT:
	        // Android端末内のエラー(その他)
//	        Toast.makeText(this, "client error", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_INSUFFICIENT_PERMISSIONS:
	        // 権限無し
//	        Toast.makeText(this, "insufficient permissions", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_NETWORK:
	        // ネットワークエラー(その他)
//	        Toast.makeText(this, "network error", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_NETWORK_TIMEOUT:
	        // ネットワークタイムアウトエラー
//	        Toast.makeText(this, "timeout", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_NO_MATCH:
	        // 音声認識結果無し
//	        Toast.makeText(this, "no match Text data", Toast.LENGTH_SHORT).show();
	    	this.changeMotion(this.motAct[0]);
	        break;
	    case SpeechRecognizer.ERROR_RECOGNIZER_BUSY:
	        // RecognitionServiceへ要求出せず
//	        Toast.makeText(this, "busy", Toast.LENGTH_SHORT).show();
	        break;
	    case SpeechRecognizer.ERROR_SERVER:
	        // Server側からエラー通知
//	        Toast.makeText(this, "server error", Toast.LENGTH_LONG).show();
	        break;
	    case SpeechRecognizer.ERROR_SPEECH_TIMEOUT:
	        // 音声入力無し
//	        Toast.makeText(this, "no input?", Toast.LENGTH_LONG).show();
	        break;
	    default:
	    	break;
	    }
	}

	@Override
	public void onEvent(int arg0, Bundle arg1) {
		// TODO 自動生成されたメソッド・スタブ
		
	}

	@Override
	public void onPartialResults(Bundle arg0) {
		// TODO 自動生成されたメソッド・スタブ
		
	}
	
	@Override
	public void onResults(Bundle results) {
		ArrayList<String> recData = results.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION);
		
		// カービィが写っていなければ声に反応しない
		if(!this._ms.isExistMarker(_mid)) {
			return;
		}
		
		// n位認識結果まで結合
	    String getData = new String();
	    for (String s : recData) {
	        getData += s + ",";
	    }
	    
	    if(getData.indexOf("おはよ") != -1 || getData.indexOf("こんにちは") != -1 || getData.indexOf("こんばんは") != -1) {
	    	this.changeMotion(this.motAct[1]);
	    	int se = this.mRandom.nextInt(2);
	    	this.mSoundPool.play(this.soundRes[se + 0], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("さよなら") != -1 || getData.indexOf("バイバイ") != -1 || getData.indexOf("またね") != -1) {
	    	this.changeMotion(this.motAct[2]);
	    	this.mSoundPool.play(this.soundRes[2], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("ばーか") != -1 || getData.indexOf("嫌い") != -1 || getData.indexOf("きもい") != -1) {
	    	this.changeMotion(this.motAct[4]);
	    	int se = this.mRandom.nextInt(2);
	    	this.mSoundPool.play(this.soundRes[6 + se], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("ファイト") != -1 || getData.indexOf("がんば") != -1) {
		    this.changeMotion(this.motAct[5]);
		    int se = this.mRandom.nextInt(2);
		    this.mSoundPool.play(this.soundRes[4 + se], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("歌って") != -1) {
	    	this.changeMotion(this.motAct[6]);
	    	this.mSoundPool.play(this.soundRes[11], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("おどって") != -1 || getData.indexOf("ダンスして") != -1) {
	    	this.changeMotion(this.motAct[7]);
	    	this.mSoundPool.play(this.soundRes[12], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("かわいい") != -1 || getData.indexOf("好き") != -1 || getData.indexOf("かっこいい") != -1) {
	    	float prob = this.mRandom.nextFloat();
	    	if(prob < 0.7) {
	    		this.changeMotion(this.motAct[3]);
		    	this.mSoundPool.play(this.soundRes[3], 1.0f, 1.0f, 0, 0, 1.0f);
	    	} else {
		    	this.changeMotion(this.motWait[1]);
		    	this.mSoundPool.play(this.soundRes[10], 1.0f, 1.0f, 0, 0, 1.0f);
	    	}
	    } else if(getData.indexOf("おやすみ") != -1) {
	    	float prob = this.mRandom.nextFloat();
	    	if(prob < 0.8) {
	    		this.changeMotion(this.motAct[2]);
		    	this.mSoundPool.play(this.soundRes[2], 1.0f, 1.0f, 0, 0, 1.0f);
	    	} else {
		    	this.changeMotion(this.motWait[3]);
		    	this.mSoundPool.play(this.soundRes[8], 1.0f, 1.0f, 0, 0, 1.0f);
	    	}
	    } else if(getData.indexOf("じゃんけん") != -1 || getData.indexOf("ジャンケン") != -1) {
	    	int prob = this.mRandom.nextInt(3);
	    	this.changeMotion(this.motAct[8 + prob]);
		    this.mSoundPool.play(this.soundRes[13], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("っちむいてほい") != -1 || getData.indexOf("っち向いてホイ") != -1) {
	    	int prob = this.mRandom.nextInt(4);
	    	this.changeMotion(this.motAct[11 + prob]);
		    this.mSoundPool.play(this.soundRes[13], 1.0f, 1.0f, 0, 0, 1.0f);
	    } else if(getData.indexOf("カービィ") != -1) {
	    	float prob = this.mRandom.nextFloat();
	    	if(prob < 0.9) {
	    		this.changeMotion(this.motAct[1]);
		    	int se = this.mRandom.nextInt(2);
		    	this.mSoundPool.play(this.soundRes[se + 0], 1.0f, 1.0f, 0, 0, 1.0f);
	    	} else {
		    	this.changeMotion(this.motWait[0]);
		    	this.mSoundPool.play(this.soundRes[9], 1.0f, 1.0f, 0, 0, 1.0f);
	    	}
	    } else {
	    	this.changeMotion(this.motAct[0]);
	    }
	    this.prob = PROB_STAND;
	 
//	    Toast.makeText(this, getData, Toast.LENGTH_SHORT).show();
	}
	
	@Override
	public void onRmsChanged(float arg0) {
		// TODO 自動生成されたメソッド・スタブ
		
	}
	
	private void detectTimeout() {
        final Handler handler = new Handler();
        if(this.mTimer == null) {
        	this.mTimer = new Timer(true);
        	this.mTimer.schedule(new TimerTask(){
	            @Override
	            public void run() {
	                // mHandlerを通じてUI Threadへ処理をキューイング
	                handler.post( new Runnable() {
	                    public void run() {
	                    	mSpeechRecognizer.cancel();
	                	    btnMic.setBackgroundResource(R.drawable.button_mic);
	                	    mTimer = null;
	                    }
	                });
	            }
	        }, 5000);
        }
	}
	
	// シャッターが押されたときに呼ばれるコールバック
	private Camera.ShutterCallback mShutterListener =
	    new Camera.ShutterCallback() {
	        public void onShutter() {
	            // TODO Auto-generated method stub
	        }
	    };
	    
	// JPEGイメージ生成後に呼ばれるコールバック
	private Camera.PictureCallback mPictureListener =
		    new Camera.PictureCallback() {
		
				@Override
		        public void onPictureTaken(byte[] data, Camera camera) {
		        	if (data == null) {
		                return;
		            }
                    makeRotateImage(data);
		        	camera.startPreview();
		        	isCaptured = false;
		        }
		    };
	
	/**
     * 格納するイメージパスを作る
     * @return
     */
    private static String makeImagePath() {
    	String saveDir = Environment.getExternalStorageDirectory().getPath();
    	Calendar cal = Calendar.getInstance();
        SimpleDateFormat sf = new SimpleDateFormat("yyyyMMdd_HHmmss");
        String imgPath = saveDir + "/Pictures/KirbyAR/";
        
        File file = new File(imgPath);
        try{
            if(!file.exists()){
                file.mkdir();
            }
        } catch(SecurityException e) {
            e.printStackTrace();
            throw e;
        }
        
        return imgPath + sf.format(cal.getTime()) + ".jpg";
    }
     
    /**
     * 回転角に合わせた画像を作る
     * @param activity アクティビティ
     * @param data 画像のビットデータ
     */
    public void makeRotateImage(byte[] data) {
        // 回転角を取り出す
        int degree = 90;//this.getCameraDisplayOrientation();
        Log.d("Degree", String.valueOf(degree));
        int destWidth = 0;
        int destHeight = 0;
         
        // 反転、もしくはそのままの場合
        if (degree % 180 == 0) {
            destWidth = this.pixelWidth;
            destHeight = this.pixelHeight;
        } else {
            destWidth = this.pixelHeight;
            destHeight = this.pixelWidth;
        }
         
        // 新しくBitmapを作る
        Bitmap bitmapDest = Bitmap.createBitmap(destWidth, destHeight, Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(bitmapDest);
        canvas.save();
         
        // キャンバスを使ってBMPを回転やら移動やらさせてデバイスの回転に合わせた画像を作る
        canvas.rotate(degree, destWidth / 2, destHeight / 2);
        int offset = (destHeight - destWidth) / 2 * ((degree - 180) % 180) / 90;
        canvas.translate(offset, -offset);
        
        // カメラ画像
        Bitmap bitmapSrc = this.makeTargetPixelImage(data, Math.max(destWidth, destHeight));
        int dx = -(bitmapSrc.getWidth()-destHeight)/2;	// = -3
        int dy = -(bitmapSrc.getHeight()-destWidth)/2;	// = -36
        canvas.drawBitmap(bitmapSrc, dx, dy, null);
		
        // MMD画像
        Bitmap bitmapMmd = this.createPixcels(destWidth, destHeight, Bitmap.Config.ARGB_8888);
        canvas.drawBitmap(bitmapMmd, 0, 0, null);
        
        canvas.restore();
        bitmapSrc.recycle();
        bitmapSrc = null;
        bitmapMmd.recycle();
        bitmapMmd = null;
        
        try {
            // 画像として書き出す
        	String path = AndMmdActivity.makeImagePath();
        	Log.d("filepath", path);
            OutputStream os = new FileOutputStream(new File(path));
            bitmapDest.compress(Bitmap.CompressFormat.JPEG, 100, os);
            os.flush();
            os.close();
    		ContentValues values = new ContentValues();
            ContentResolver contentResolver = AndMmdActivity.this.getContentResolver();
            values.put(Images.Media.MIME_TYPE, "image/jpeg");
            values.put("_data", path);
            contentResolver.insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);
        } catch (Exception e) {
            e.printStackTrace();
        }
 
    }
    
    /**
     * 指定されたピクセル内に収まるようなBMPイメージを作る
     * @param data
     * @param maxPixel
     * @return
     */
    private Bitmap makeTargetPixelImage(byte[] data, int maxPixel) {
         
        BitmapFactory.Options option = new BitmapFactory.Options();
         
        // 情報だけ取り出す
        option.inJustDecodeBounds = true;
        BitmapFactory.decodeByteArray(data, 0, data.length, option);
         
        int w = option.outWidth;
    	int h = option.outHeight;
        
        // 指定されたピクセル数より多いBMPの場合は小さくする
        if (maxPixel < Math.max(w,h)) {
        	int scale = Math.max(w,h) / maxPixel + 1;
    		option.inSampleSize = scale;
        }
         
        // 実際の画像を読み込む
        // 
         
        // データまで読み込み
        option.inJustDecodeBounds = false;
         
        // 指定サイズの画像を作る
        return BitmapFactory.decodeByteArray(data, 0, data.length, option);
         
    }
	
	private Bitmap createPixcels(/*final int[] pixels, */final int width, final int height, final Bitmap.Config config) {
		final Paint paint = new Paint(Paint.FILTER_BITMAP_FLAG);
		// R (赤) と B (青) が逆なので交換します。
		paint.setColorFilter(new ColorMatrixColorFilter(new ColorMatrix(new float[] {
				0, 0, 1, 0, 0,
				0, 1, 0, 0, 0,
				1, 0, 0, 0, 0,
				0, 0, 0, 1, 0
			})));

		final Bitmap bitmap = Bitmap.createBitmap(height, width, config);
//		final Bitmap bitmap = Bitmap.createBitmap(width, height, config);	//ok
		final Canvas canvas = new Canvas(bitmap);

		// 上下が逆さまなので垂直方向に反転させます。
		final Matrix matrix = new Matrix();
		matrix.postScale(1.0f, -1.0f);
		matrix.postTranslate(0, height);	//ok
		canvas.concat(matrix);

		// 描画します。
//		canvas.drawBitmap(this.mPixels, 0, width, 0, 0, width, height, false, paint);	//ok
		canvas.drawBitmap(this.mPixels, 0, height, 0, width/2, height, width, true, paint);

		return bitmap;
	}
}


