///*
// * Copyright (C) 2006 The Android Open Source Project
// *
// * Licensed under the Apache License, Version 2.0 (the "License");
// * you may not use this file except in compliance with the License.
// * You may obtain a copy of the License at
// *
// *      http://www.apache.org/licenses/LICENSE-2.0
// *
// * Unless required by applicable law or agreed to in writing, software
// * distributed under the License is distributed on an "AS IS" BASIS,
// * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// * See the License for the specific language governing permissions and
// * limitations under the License.
// */
//
//package jp.nyatla.andnya3;
//
//import android.content.Context;
//import android.database.ContentObserver;
//import android.os.Handler;
//import android.os.SystemClock;
//import android.provider.Settings;
//import android.util.AttributeSet;
//
//import java.util.Calendar;
//import java.util.TimeZone;
//
//public class MyDigitalClock {
//    // FIXME: implement separate views for hours/minutes/seconds, so
//    // proportional fonts don't shake rendering
//
//    Calendar mCalendar;
//    private final static String m12 = "h:mm:ss aa";
//    private final static String m24 = "k:mm:ss";
//    private FormatChangeObserver mFormatChangeObserver;
//
//    private Runnable mTicker;
//    private Handler mHandler;
//
//    private boolean mTickerStopped = false;
//
//    String mFormat;
//
//    public MyDigitalClock(Context context) {
//        super(context);
//        this.initClock();
//    }
//
//    public MyDigitalClock(Context context, AttributeSet attrs) {
//        super(context, attrs);
//        initClock();
//    }
//
//    private void initClock() {
//        if (mCalendar == null) {
//            mCalendar = Calendar.getInstance();
//        }
//
//        mFormatChangeObserver = new FormatChangeObserver();
//        getContext().getContentResolver().registerContentObserver(
//                Settings.System.CONTENT_URI, true, mFormatChangeObserver);
//
//        setFormat();
//    }
//
//    @Override
//    protected void onAttachedToWindow() {
//        mTickerStopped = false;
//        super.onAttachedToWindow();
//        mHandler = new Handler();
//
//        /**
//         * requests a tick on the next hard-second boundary
//         */
//        mTicker = new Runnable() {
//            public void run() {
//                if (mTickerStopped) return;
//                mCalendar.setTimeInMillis(System.currentTimeMillis());
////                setText(DateFormat.format(mFormat, mCalendar));
//                invalidate();
//                long oneDay = 24 * 60 * 60 * 1000;
//                long now = SystemClock.uptimeMillis();
//                long nextTime = now + (1000 - mCalendar.getTimeInMillis() % 1000);
//                long nextDate = now + (oneDay - ((System.currentTimeMillis() + TimeZone.getDefault().getRawOffset()) % oneDay));
//                mHandler.postAtTime(mTicker, nextTime);
//            }
//        };
//        mTicker.run();
//    }
//
//    @Override
//    protected void onDetachedFromWindow() {
//        super.onDetachedFromWindow();
//        mTickerStopped = true;
//    }
//
//    /**
//     * Pulls 12/24 mode from system settings
//     */
//    private boolean get24HourMode() {
//        return android.text.format.DateFormat.is24HourFormat(getContext());
//    }
//
//    private void setFormat() {
//        if (get24HourMode()) {
//            mFormat = m24;
//        } else {
//            mFormat = m12;
//        }
//    }
//
//    private class FormatChangeObserver extends ContentObserver {
//        public FormatChangeObserver() {
//            super(new Handler());
//        }
//
//        @Override
//        public void onChange(boolean selfChange) {
//            setFormat();
//        }
//    }
//}